"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execState = exports.evalState = exports.stateEither = exports.MonadThrow = exports.Monad = exports.Apply = exports.Applicative = exports.Functor = exports.URI = exports.flatten = exports.chainEitherK = exports.chainFirst = exports.chain = exports.of = exports.apSecond = exports.apFirst = exports.ap = exports.map = exports.filterOrElse = exports.fromPredicate = exports.fromEitherK = exports.fromEither = exports.fromOption = exports.rightState = exports.leftState = exports.right = exports.left = exports.gets = exports.modify = exports.put = exports.get = void 0;
var E = __importStar(require("fp-ts/lib/Either"));
var function_1 = require("fp-ts/lib/function");
var pipeable_1 = require("fp-ts/lib/pipeable");
var StateT_1 = require("fp-ts/lib/StateT");
var T = (0, StateT_1.getStateM)(E.either);
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 0.1.12
 */
exports.get = T.get;
/**
 * @category constructors
 * @since 0.1.12
 */
exports.put = T.put;
/**
 * @category constructors
 * @since 0.1.12
 */
exports.modify = T.modify;
/**
 * @category constructors
 * @since 0.1.12
 */
exports.gets = T.gets;
/**
 * @category constructors
 * @since 0.1.12
 */
var left = function (e) { return (0, exports.fromEither)(E.left(e)); };
exports.left = left;
/**
 * @category constructors
 * @since 0.1.12
 */
exports.right = T.of;
/**
 * @category constructors
 * @since 0.1.12
 */
var leftState = function (me) { return function (s) {
    return E.left(me(s)[0]);
}; };
exports.leftState = leftState;
/**
 * @category constructors
 * @since 0.1.12
 */
exports.rightState = T.fromState;
/**
 * @category constructors
 * @since 0.1.18
 */
var fromOption = function (onNone) { return function (ma) {
    return ma._tag === 'None' ? (0, exports.left)(onNone()) : (0, exports.right)(ma.value);
}; };
exports.fromOption = fromOption;
/**
 * @category constructors
 * @since 0.1.0
 */
exports.fromEither = T.fromM;
/**
 * @category constructors
 * @since 0.1.12
 */
var fromEitherK = function (f) { return function () {
    var a = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        a[_i] = arguments[_i];
    }
    return (0, exports.fromEither)(f.apply(void 0, a));
}; };
exports.fromEitherK = fromEitherK;
/**
 * @category constructors
 * @since 0.1.18
 */
var fromPredicate = function (predicate, onFalse) { return function (a) {
    return predicate(a) ? (0, exports.right)(a) : (0, exports.left)(onFalse(a));
}; };
exports.fromPredicate = fromPredicate;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 0.1.18
 */
var filterOrElse = function (predicate, onFalse) { return function (ma) {
    return T.chain(ma, function (a) { return (predicate(a) ? (0, exports.right)(a) : (0, exports.left)(onFalse(a))); });
}; };
exports.filterOrElse = filterOrElse;
// -------------------------------------------------------------------------------------
// pipeables
// -------------------------------------------------------------------------------------
/**
 * @category Functor
 * @since 0.1.18
 */
var map = function (f) { return function (fa) {
    return T.map(fa, f);
}; };
exports.map = map;
/**
 * @category Apply
 * @since 0.1.18
 */
var ap = function (fa) { return function (fab) { return T.ap(fab, fa); }; };
exports.ap = ap;
/**
 * @category Apply
 * @since 0.1.18
 */
var apFirst = function (fb) { return function (fa) {
    return (0, pipeable_1.pipe)(fa, (0, exports.map)(function (a) { return function (_) { return a; }; }), (0, exports.ap)(fb));
}; };
exports.apFirst = apFirst;
/**
 * @category Apply
 * @since 0.1.18
 */
var apSecond = function (fb) { return function (fa) {
    return (0, pipeable_1.pipe)(fa, (0, exports.map)(function () { return function (b) { return b; }; }), (0, exports.ap)(fb));
}; };
exports.apSecond = apSecond;
/**
 * @category Applicative
 * @since 0.1.18
 */
exports.of = exports.right;
/**
 * @category Monad
 * @since 0.1.18
 */
var chain = function (f) { return function (ma) { return T.chain(ma, f); }; };
exports.chain = chain;
/**
 * @category Monad
 * @since 0.1.18
 */
var chainFirst = function (f) { return function (ma) { return T.chain(ma, function (a) { return T.map(f(a), function () { return a; }); }); }; };
exports.chainFirst = chainFirst;
/**
 * @since 0.1.12
 */
var chainEitherK = function (f) { return (0, exports.chain)((0, exports.fromEitherK)(f)); };
exports.chainEitherK = chainEitherK;
/**
 * @category Monad
 * @since 0.1.18
 */
var flatten = function (mma) {
    return T.chain(mma, function_1.identity);
};
exports.flatten = flatten;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 0.1.12
 */
exports.URI = 'StateEither';
/**
 * @category instances
 * @since 0.1.18
 */
exports.Functor = {
    URI: exports.URI,
    map: T.map
};
/**
 * @category instances
 * @since 0.1.18
 */
exports.Applicative = {
    URI: exports.URI,
    map: T.map,
    ap: T.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 0.1.18
 */
exports.Apply = {
    URI: exports.URI,
    map: T.map,
    ap: T.ap
};
/**
 * @category instances
 * @since 0.1.18
 */
exports.Monad = {
    URI: exports.URI,
    map: T.map,
    ap: T.ap,
    chain: T.chain,
    of: exports.of
};
/**
 * @category instances
 * @since 0.1.18
 */
exports.MonadThrow = {
    URI: exports.URI,
    map: T.map,
    ap: T.ap,
    chain: T.chain,
    of: exports.of,
    throwError: exports.left
};
/**
 * @category instances
 * @since 0.1.12
 */
exports.stateEither = {
    URI: exports.URI,
    map: T.map,
    of: exports.right,
    ap: T.ap,
    chain: T.chain,
    throwError: exports.left
};
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 0.1.12
 */
exports.evalState = T.evalState;
/**
 * @since 0.1.12
 */
exports.execState = T.execState;
